#version 130
#extension GL_EXT_gpu_shader3 : enable
#extension GL_EXT_gpu_shader4 : enable

uniform int lightNumber;
uniform int lightRecieve[7];

uniform sampler2D textureColorCurve;
uniform sampler2D textureImage[3];

uniform int dissolveMode;

flat in int blend;
flat in int textureImageIndex;

void main(){
    
    vec4 texColor;
    
    vec4 clrBase = vec4(1, 1, 1, 1);

    switch(textureImageIndex){
    case 0:
	if (textureSize(textureImage[0], 0).x > 1)
	    texColor = texture2D(textureImage[0], vec2(0.5, 0.5)) * clrBase;
	else{
	    texColor = clrBase;
	}
	break;
    case 1:
	if (textureSize(textureImage[1], 0).x > 1)
	    texColor = texture2D(textureImage[1], vec2(0.5, 0.5)) * clrBase;
	else{
	    texColor = clrBase;
	}
	break;
    case 2:
	if (textureSize(textureImage[2], 0).x > 1)
	    texColor = texture2D(textureImage[2], vec2(0.5, 0.5)) * clrBase;
	else{
	    texColor = clrBase;
	}
	break;
    default:
	texColor = clrBase;
	break;
    }
    
    float alpha = texColor[3];
    if (alpha == 0) discard;

    gl_FragColor = vec4(1, 0, 1, 1);
}
