#version 130
#extension GL_EXT_gpu_shader3 : enable
//#extension GL_EXT_gpu_shader4 : enable

uniform int lightNumber;

uniform int textureMode;
uniform sampler1D textureColorCurve;
uniform int fogMode;
uniform int dissolveMode;

uniform vec2 ensembleParamA;
uniform float ensembleParamB;
uniform vec2 ensembleParamC;

uniform float projInv11;
uniform float projInv15;

in vec4 color;
in vec3 position;
flat in int lineIndex;

//##FUNC_ENSEMBLE_DITHERING##

//##FUNC_FOG_EFFECT##

void main(void)
{
    if (lineIndex == -1) discard;
    
    vec4 texColor = texture1D(textureColorCurve, gl_TexCoord[0].s);
    if (textureMode == 0) texColor = vec4(1, 1, 1, 1);
    
    float alpha = texColor[3];
    if (alpha == 0) discard;

    //##APPLY_ENSEMBLE_DITHERING##
    
    gl_FragColor.r = color.r * texColor.r;
    gl_FragColor.g = color.g * texColor.g;
    gl_FragColor.b = color.b * texColor.b;

    FogEffect();
    
    alpha *= color.a;

    int blend = 0;
    if (blend == 0){
	gl_FragColor.rgb *= alpha;
	gl_FragColor.a = alpha;
    }
    else{
	gl_FragColor.rgb *= alpha;
	gl_FragColor.a = 0;
    }
    
}
