//#extension GL_EXT_gpu_shader4 : enable

uniform sampler3D textureVolume;
uniform sampler1D textureCC;
uniform int forceDiscard0;
uniform int trim;

varying vec3 position;

//##FUNC_VOLUME_MASK_BEGIN##
bool GetMask(vec3 texCoord){
    return true;
}
//##FUNC_VOLUME_MASK_END##

//##FUNC_VOLUME_COORD_BEGIN##
//#define GTRIM 1
vec3 GetDeformCoord(vec3 vecOrg){
    return vecOrg;
}
//##FUNC_VOLUME_COORD_END##

void main (void)
{
   
    gl_FragColor = vec4(0, 0, 0 ,0);

    vec3 texCoord = vec3(gl_TexCoord[0]);
    vec3 deformedCoord = GetDeformCoord(gl_TexCoord[0]);
    if (GetMask(deformedCoord) == false) discard;
    
    vec4 texColor = texture3D(textureVolume, deformedCoord);

#if GTRIM
    if (deformedCoord.x < 0 || deformedCoord.x > 1) discard;
    if (deformedCoord.y < 0 || deformedCoord.y > 1) discard;
    if (deformedCoord.z < 0 || deformedCoord.z > 1) discard;
#else
    if (trim == 1){
	if (deformedCoord.x < 0 || deformedCoord.x > 1) discard;
	if (deformedCoord.y < 0 || deformedCoord.y > 1) discard;
	if (deformedCoord.z < 0 || deformedCoord.z > 1) discard;
    }
#endif

    float value = texColor[0];
    if (forceDiscard0 == 1 && value == 0) discard;
    
    vec4 texColor2 = texture1D(textureCC, value);

    gl_FragColor += texColor2 * gl_Color;
    
    /*
    if (gl_FragColor[3] > 1){
	gl_FragColor[0] *= gl_FragColor[3];
	gl_FragColor[1] *= gl_FragColor[3];
	gl_FragColor[2] *= gl_FragColor[3];
	gl_FragColor[3] = 1;
    }
    */

    return;
}
